【HDU3555】数位Dp1~n之间出现特征数字个数

来源:互联网 发布:怎么在淘宝买发票 编辑:程序博客网 时间:2024/06/09 17:11

Bomb

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 7279    Accepted Submission(s): 2541


Problem Description
The counter-terrorists found a time bomb in the dust. But this time the terrorists improve on the time bomb. The number sequence of the time bomb counts from 1 to N. If the current number sequence includes the sub-sequence "49", the power of the blast would add one point.
Now the counter-terrorist knows the number N. They want to know the final points of the power. Can you help them?
 

Input
The first line of input consists of an integer T (1 <= T <= 10000), indicating the number of test cases. For each test case, there will be an integer N (1 <= N <= 2^63-1) as the description.

The input terminates by end of file marker.
 

Output
For each test case, output an integer indicating the final points of the power.
 

Sample Input
3150500
 

Sample Output
0115
Hint
From 1 to 500, the numbers that include the sub-sequence "49" are "49","149","249","349","449","490","491","492","493","494","495","496","497","498","499",so the answer is 15.
 

Author
fatboy_cw@WHU
 

Source
2010 ACM-ICPC Multi-University Training Contest(12)——Host by WHU

转自:http://blog.csdn.net/winkloud/article/details/7866520

做的第一道数位DP啊!开始在找规律,搜索,做了很久终于找到了规律,上网一查发现原来这样的叫数位DP。。

找到的规律就是这个样子了。有了规律就很好做了。dp[i][0]=dp[i-1][0]*10-dp[i-1][1];是因为要减去49XXX的情况。


题意就是找0到n有多少个数中含有49。数据范围接近10^20

DP的状态是2维的dp[len][3]
dp[len][0] 代表长度为len不含49的方案数
dp[len][1] 代表长度为len不含49但是以9开头的数字的方案数
dp[len][2] 代表长度为len含有49的方案数

状态转移如下
dp[i][0] = dp[i-1][0] * 10 - dp[i-1][1];  // not include 49  如果不含49且,在前面可以填上0-9 但是要减去dp[i-1][1] 因为4会和9构成49
dp[i][1] = dp[i-1][0];  // not include 49 but starts with 9  这个直接在不含49的数上填个9就行了
dp[i][2] = dp[i-1][2] * 10 + dp[i-1][1]; // include 49  已经含有49的数可以填0-9,或者9开头的填4

接着就是从高位开始统计

在统计到某一位的时候,加上 dp[i-1][2] * digit[i] 是显然对的,因为这一位可以填 0 - (digit[i]-1)
若这一位之前挨着49,那么加上 dp[i-1][0] * digit[i] 也是显然对的。
若这一位之前没有挨着49,但是digit[i]比4大,那么当这一位填4的时候,就得加上dp[i-1][1]


//Time:15MS//Memory:488K#include<string.h>#include<stdio.h>long long dp[20][3];int num[20];int main(){    memset(dp,0,sizeof(dp));    dp[0][0] = 1;    for(int i = 1;i<= 20;i++){        dp[i][0]=dp[i-1][0]*10-dp[i-1][1]; //dp[i][0] 表示i位数字中不含49的数字的个数        dp[i][1]=dp[i-1][0];               //dp[i][1] 表示i位数字中以9开头的数字的个数        dp[i][2]=dp[i-1][2]*10+dp[i-1][1];//dp[i][2] 表示i位数字中含有49的数字的个数    }    int t;    scanf("%d",&t);    while(t--){        int len = 0,last = 0;        long long ans = 0;        long long n = 0;        scanf("%I64d",&n);        n++;        memset(num,0,sizeof(num));        while(n){            num[++len]=n%10;            n/=10;        }        bool flag=false;        for(int i=len;i>=1;i--){            ans+=dp[i-1][2]*num[i];            if(flag){                ans+=dp[i-1][0]*num[i];            }            if(!flag && num[i]>4){                ans+=dp[i-1][1];            }            if(last==4 && num[i]==9){                flag=true;            }            last=num[i];        }        printf("%I64d\n",ans);    }}



0 0